Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/DYN/dynspg_ts.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/DYN/dynspg_ts.F90	(revision 14063)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/DYN/dynspg_ts.F90	(revision 14065)
@@ -1229,16 +1218,16 @@
       !!----------------------------------------------------------------------
       !
-      IF( ln_wd_dl_rmp ) THEN
+      IF( ln_wd_dl_rmp ) THEN     
          DO_2D( 1, 1, 1, 1 )
-            IF    ( pssh(ji,jj) + ht_0(ji,jj) >  2._wp * rn_wdmin1 ) THEN
-               !           IF    ( pssh(ji,jj) + ht_0(ji,jj) >          rn_wdmin2 ) THEN
+            IF    ( pssh(ji,jj) + ht_0(ji,jj) >  2._wp * rn_wdmin1 ) THEN 
+               !           IF    ( pssh(ji,jj) + ht_0(ji,jj) >          rn_wdmin2 ) THEN 
                ptmsk(ji,jj) = 1._wp
             ELSEIF( pssh(ji,jj) + ht_0(ji,jj) >          rn_wdmin1 ) THEN
                ptmsk(ji,jj) = TANH( 50._wp*( ( pssh(ji,jj) + ht_0(ji,jj) -  rn_wdmin1 )*r_rn_wdmin1) )
-            ELSE
+            ELSE 
                ptmsk(ji,jj) = 0._wp
             ENDIF
          END_2D
-      ELSE
+      ELSE  
          DO_2D( 1, 1, 1, 1 )
             IF ( pssh(ji,jj) + ht_0(ji,jj) >  rn_wdmin1 ) THEN   ;   ptmsk(ji,jj) = 1._wp
@@ -1254,9 +1243,9 @@
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE wad_lmt  ***
-      !!
-      !! ** Purpose :   set wetting & drying mask at tracer points
-      !!              for the current barotropic sub-step
-      !!
-      !! ** Method  :   ???
+      !!                    
+      !! ** Purpose :   set wetting & drying mask at tracer points 
+      !!              for the current barotropic sub-step 
+      !!
+      !! ** Method  :   ??? 
       !!
       !! ** Action  :  ptmsk : wetting & drying t-mask
@@ -1270,6 +1259,6 @@
       !
       DO_2D( 1, 1, 1, 0 )   ! not jpi-column
-         IF ( phU(ji,jj) > 0._wp ) THEN   ;   pUmsk(ji,jj) = pTmsk(ji  ,jj)
-         ELSE                             ;   pUmsk(ji,jj) = pTmsk(ji+1,jj)
+         IF ( phU(ji,jj) > 0._wp ) THEN   ;   pUmsk(ji,jj) = pTmsk(ji  ,jj) 
+         ELSE                             ;   pUmsk(ji,jj) = pTmsk(ji+1,jj)  
          ENDIF
          phU(ji,jj) = pUmsk(ji,jj)*phU(ji,jj)
@@ -1279,7 +1268,7 @@
       DO_2D( 1, 0, 1, 1 )   ! not jpj-row
          IF ( phV(ji,jj) > 0._wp ) THEN   ;   pVmsk(ji,jj) = pTmsk(ji,jj  )
-         ELSE                             ;   pVmsk(ji,jj) = pTmsk(ji,jj+1)
-         ENDIF
-         phV(ji,jj) = pVmsk(ji,jj)*phV(ji,jj)
+         ELSE                             ;   pVmsk(ji,jj) = pTmsk(ji,jj+1)  
+         ENDIF
+         phV(ji,jj) = pVmsk(ji,jj)*phV(ji,jj) 
          pv (ji,jj) = pVmsk(ji,jj)*pv (ji,jj)
       END_2D
@@ -1292,5 +1281,5 @@
       !!                   ***  ROUTINE  wad_sp  ***
       !!
-      !! ** Purpose :
+      !! ** Purpose : 
       !!----------------------------------------------------------------------
       INTEGER  ::   ji ,jj               ! dummy loop indices
@@ -1325,5 +1314,5 @@
               &      MAX(   pshn(ji,jj)              ,  pshn(ji,jj+1) ) >                &
               &      MAX(  -ht_0(ji,jj)              , -ht_0(ji,jj+1) ) + rn_wdmin1 + rn_wdmin2 )
-
+         
          IF(ll_tmp1) THEN
             zcpy(ji,jj) = 1.0_wp
@@ -1337,17 +1326,17 @@
          ENDIF
       END_2D
-
+            
    END SUBROUTINE wad_spg
-
+     
 
    SUBROUTINE dyn_drg_init( Kbb, Kmm, puu, pvv, puu_b ,pvv_b, pu_RHSi, pv_RHSi, pCdU_u, pCdU_v )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE dyn_drg_init  ***
-      !!
-      !! ** Purpose : - add the baroclinic top/bottom drag contribution to
+      !!                    
+      !! ** Purpose : - add the baroclinic top/bottom drag contribution to 
       !!              the baroclinic part of the barotropic RHS
       !!              - compute the barotropic drag coefficients
       !!
-      !! ** Method  :   computation done over the INNER domain only
+      !! ** Method  :   computation done over the INNER domain only 
       !!----------------------------------------------------------------------
       INTEGER                             , INTENT(in   ) ::  Kbb, Kmm           ! ocean time level indices
@@ -1366,5 +1355,5 @@
       !
       IF( ln_isfcav.OR.ln_drgice_imp ) THEN          ! top+bottom friction (ocean cavities)
-
+         
          DO_2D( 0, 0, 0, 0 )
             pCdU_u(ji,jj) = r1_2*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) + rCdU_top(ji+1,jj)+rCdU_top(ji,jj) )
@@ -1381,16 +1370,16 @@
       !
       IF( ln_bt_fw ) THEN                 ! FORWARD integration: use NOW bottom baroclinic velocities
-
+         
          DO_2D( 0, 0, 0, 0 )
-            ikbu = mbku(ji,jj)
-            ikbv = mbkv(ji,jj)
+            ikbu = mbku(ji,jj)       
+            ikbv = mbkv(ji,jj)    
             zu_i(ji,jj) = puu(ji,jj,ikbu,Kmm) - puu_b(ji,jj,Kmm)
             zv_i(ji,jj) = pvv(ji,jj,ikbv,Kmm) - pvv_b(ji,jj,Kmm)
          END_2D
       ELSE                                ! CENTRED integration: use BEFORE bottom baroclinic velocities
-
+         
          DO_2D( 0, 0, 0, 0 )
-            ikbu = mbku(ji,jj)
-            ikbv = mbkv(ji,jj)
+            ikbu = mbku(ji,jj)       
+            ikbv = mbkv(ji,jj)    
             zu_i(ji,jj) = puu(ji,jj,ikbu,Kbb) - puu_b(ji,jj,Kbb)
             zv_i(ji,jj) = pvv(ji,jj,ikbv,Kbb) - pvv_b(ji,jj,Kbb)
@@ -1401,11 +1390,11 @@
          zztmp = -1._wp / rDt_e
          DO_2D( 0, 0, 0, 0 )
-            pu_RHSi(ji,jj) = pu_RHSi(ji,jj) + zu_i(ji,jj) *  wdrampu(ji,jj) * MAX(                                 &
+            pu_RHSi(ji,jj) = pu_RHSi(ji,jj) + zu_i(ji,jj) *  wdrampu(ji,jj) * MAX(                                 & 
                  &                              r1_hu(ji,jj,Kmm) * r1_2*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) ) , zztmp  )
-            pv_RHSi(ji,jj) = pv_RHSi(ji,jj) + zv_i(ji,jj) *  wdrampv(ji,jj) * MAX(                                 &
+            pv_RHSi(ji,jj) = pv_RHSi(ji,jj) + zv_i(ji,jj) *  wdrampv(ji,jj) * MAX(                                 & 
                  &                              r1_hv(ji,jj,Kmm) * r1_2*( rCdU_bot(ji,jj+1)+rCdU_bot(ji,jj) ) , zztmp  )
          END_2D
       ELSE                    ! use "unclipped" drag (even if explicit friction is used in 3D calculation)
-
+         
          DO_2D( 0, 0, 0, 0 )
             pu_RHSi(ji,jj) = pu_RHSi(ji,jj) + r1_hu(ji,jj,Kmm) * r1_2*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) ) * zu_i(ji,jj)
@@ -1419,5 +1408,5 @@
          !
          IF( ln_bt_fw ) THEN                ! FORWARD integration: use NOW top baroclinic velocity
-
+            
             DO_2D( 0, 0, 0, 0 )
                iktu = miku(ji,jj)
@@ -1427,5 +1416,5 @@
             END_2D
          ELSE                                ! CENTRED integration: use BEFORE top baroclinic velocity
-
+            
             DO_2D( 0, 0, 0, 0 )
                iktu = miku(ji,jj)
@@ -1437,5 +1426,5 @@
          !
          !                    ! use "unclipped" top drag (even if explicit friction is used in 3D calculation)
-
+         
          DO_2D( 0, 0, 0, 0 )
             pu_RHSi(ji,jj) = pu_RHSi(ji,jj) + r1_hu(ji,jj,Kmm) * r1_2*( rCdU_top(ji+1,jj)+rCdU_top(ji,jj) ) * zu_i(ji,jj)
@@ -1458,6 +1447,6 @@
       !                             ! set Half-step back interpolation coefficient
       IF    ( jn==1 .AND. ll_init ) THEN   !* Forward-backward
-         za0 = 1._wp
-         za1 = 0._wp
+         za0 = 1._wp                        
+         za1 = 0._wp                           
          za2 = 0._wp
          za3 = 0._wp
@@ -1466,7 +1455,7 @@
          za1 =-0.1666666666666_wp                 ! za1 = gam
          za2 = 0.0833333333333_wp                 ! za2 = eps
-         za3 = 0._wp
-      ELSE                                 !* AB3-AM4 Coefficients; bet=0.281105 ; eps=0.013 ; gam=0.0880
-         IF( rn_bt_alpha == 0._wp ) THEN      ! Time diffusion
+         za3 = 0._wp              
+      ELSE                                 !* AB3-AM4 Coefficients; bet=0.281105 ; eps=0.013 ; gam=0.0880 
+         IF( rn_bt_alpha == 0._wp ) THEN      ! Time diffusion  
             za0 = 0.614_wp                        ! za0 = 1/2 +   gam + 2*eps
             za1 = 0.285_wp                        ! za1 = 1/2 - 2*gam - 3*eps
@@ -1480,5 +1469,5 @@
             za2 = zgamma
             za3 = zepsilon
-         ENDIF
+         ENDIF 
       ENDIF
    END SUBROUTINE ts_bck_interp
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/IOM/iom.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/IOM/iom.F90	(revision 14063)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/IOM/iom.F90	(revision 14065)
@@ -2280,5 +2280,5 @@
       !
       CALL iom_set_domain_attr("grid_"//cdgrd, ni_glo=Ni0glo,nj_glo=Nj0glo,ibegin=mig0(Nis0)-1,jbegin=mjg0(Njs0)-1,ni=Ni_0,nj=Nj_0)
-      CALL iom_set_domain_attr("grid_"//cdgrd, data_dim=2, data_ibegin = -nn_hls, data_ni = jpi, data_jbegin = -nn_hls, data_nj = jpj)
+      CALL iom_set_domain_attr("grid_"//cdgrd, data_dim=2, data_ibegin = -nn_hls, data_ni=jpi, data_jbegin = -nn_hls, data_nj=jpj)
 !don't define lon and lat for restart reading context.
       IF ( .NOT.ldrxios ) &
@@ -2289,7 +2289,9 @@
          ! mask land points, keep values on coast line -> specific mask for U, V and W points
          SELECT CASE ( cdgrd )
-         CASE('T')   ;   zmask(:,:,:)       = tmask(:,:,:)
-         CASE('U')   ;   zmask(2:jpim1,:,:) = tmask(2:jpim1,:,:) + tmask(3:jpi,:,:)
-         CASE('V')   ;   zmask(:,2:jpjm1,:) = tmask(:,2:jpjm1,:) + tmask(:,3:jpj,:)
+         CASE('T')   ;   zmask( :     , :     ,:) = tmask(:,:,:)
+         CASE('U')   ;   zmask(2:jpim1, :     ,:) = tmask(2:jpim1, :     ,:) + tmask(3:jpi  , :   ,:)
+         CASE('V')   ;   zmask( :     ,2:jpjm1,:) = tmask( :     ,2:jpjm1,:) + tmask( :     ,3:jpj,:)
+         CASE('F')   ;   zmask(2:jpim1,2:jpjm1,:) = tmask(2:jpim1,2:jpjm1,:) + tmask(2:jpim1,3:jpj,:)    &
+            &                                     + tmask(3:jpi  ,2:jpjm1,:) + tmask(3:jpi  ,3:jpj,:)
          CASE('W')   ;   zmask(:,:,2:jpk  ) = tmask(:,:,1:jpkm1) + tmask(:,:,2:jpk)   ;   zmask(:,:,1) = tmask(:,:,1)
          END SELECT
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/ISF/isf_oce.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/ISF/isf_oce.F90	(revision 14063)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/ISF/isf_oce.F90	(revision 14065)
@@ -1,6 +1,6 @@
 MODULE isf_oce
    !!======================================================================
-   !!                       ***  MODULE  sbcisf  ***
-   !! Surface module :  compute iceshelf melt and heat flux
+   !!                       ***  MODULE  isf_oce  ***
+   !! Ice shelves :  ice shelves variables defined in memory
    !!======================================================================
    !! History :  3.2  !  2011-02  (C.Harris  ) Original code isf cav
@@ -146,4 +146,5 @@
    END SUBROUTINE isf_alloc_par
 
+   
    SUBROUTINE isf_alloc_cav()
       !!---------------------------------------------------------------------
@@ -173,4 +174,5 @@
    END SUBROUTINE isf_alloc_cav
 
+   
    SUBROUTINE isf_alloc_cpl()
       !!---------------------------------------------------------------------
@@ -184,14 +186,14 @@
       ierr = 0
       !
-      ALLOCATE( risfcpl_ssh(jpi,jpj), risfcpl_tsc(jpi,jpj,jpk,jpts), risfcpl_vol(jpi,jpj,jpk), STAT=ialloc )
-      ierr = ierr + ialloc
-      !
-      risfcpl_tsc(:,:,:,:) = 0.0 ; risfcpl_vol(:,:,:) = 0.0 ; risfcpl_ssh(:,:) = 0.0
-
-      IF ( ln_isfcpl_cons) THEN
-         ALLOCATE( risfcpl_cons_tsc(jpi,jpj,jpk,jpts) , risfcpl_cons_vol(jpi,jpj,jpk) ,risfcpl_cons_ssh(jpi,jpj), STAT=ialloc )
+      ALLOCATE( risfcpl_ssh(jpi,jpj) , risfcpl_tsc(jpi,jpj,jpk,jpts) , risfcpl_vol(jpi,jpj,jpk) , STAT=ialloc )
+      ierr = ierr + ialloc
+      !
+      risfcpl_tsc(:,:,:,:) = 0._wp ; risfcpl_vol(:,:,:) = 0._wp ; risfcpl_ssh(:,:) = 0._wp
+
+      IF ( ln_isfcpl_cons ) THEN
+         ALLOCATE( risfcpl_cons_tsc(jpi,jpj,jpk,jpts) , risfcpl_cons_vol(jpi,jpj,jpk) , risfcpl_cons_ssh(jpi,jpj) , STAT=ialloc )
          ierr = ierr + ialloc
          !
-         risfcpl_cons_tsc(:,:,:,:) = 0.0 ; risfcpl_cons_vol(:,:,:) = 0.0 ; risfcpl_cons_ssh(:,:) = 0.0
+         risfcpl_cons_tsc(:,:,:,:) = 0._wp ; risfcpl_cons_vol(:,:,:) = 0._wp ; risfcpl_cons_ssh(:,:) = 0._wp
          !
       END IF
@@ -202,4 +204,5 @@
    END SUBROUTINE isf_alloc_cpl
 
+   
    SUBROUTINE isf_dealloc_cpl()
       !!---------------------------------------------------------------------
@@ -213,5 +216,5 @@
       ierr = 0
       !
-      DEALLOCATE( risfcpl_ssh, risfcpl_tsc, risfcpl_vol, STAT=ialloc )
+      DEALLOCATE( risfcpl_ssh , risfcpl_tsc , risfcpl_vol , STAT=ialloc )
       ierr = ierr + ialloc
       !
@@ -221,4 +224,5 @@
    END SUBROUTINE isf_dealloc_cpl
 
+   
    SUBROUTINE isf_alloc()
       !!---------------------------------------------------------------------
@@ -233,19 +237,19 @@
       ierr = 0       ! set to zero if no array to be allocated
       !
-      ALLOCATE(fwfisf_par(jpi,jpj)  , fwfisf_par_b(jpi,jpj), &
-         &     fwfisf_cav(jpi,jpj)  , fwfisf_cav_b(jpi,jpj), &
-         &     fwfisf_oasis(jpi,jpj),            STAT=ialloc )
-      ierr = ierr + ialloc
-      !
-      ALLOCATE(risf_par_tsc(jpi,jpj,jpts), risf_par_tsc_b(jpi,jpj,jpts), STAT=ialloc )
-      ierr = ierr + ialloc
-      !
-      ALLOCATE(risf_cav_tsc(jpi,jpj,jpts), risf_cav_tsc_b(jpi,jpj,jpts), STAT=ialloc )
-      ierr = ierr + ialloc
-      !
-      ALLOCATE(risfload(jpi,jpj), STAT=ialloc)
-      ierr = ierr + ialloc
-      !
-      ALLOCATE( mskisf_cav(jpi,jpj), STAT=ialloc)
+      ALLOCATE( fwfisf_par  (jpi,jpj) , fwfisf_par_b(jpi,jpj) ,     &
+         &      fwfisf_cav  (jpi,jpj) , fwfisf_cav_b(jpi,jpj) ,     &
+         &      fwfisf_oasis(jpi,jpj)                         , STAT=ialloc )
+      ierr = ierr + ialloc
+      !
+      ALLOCATE( risf_par_tsc(jpi,jpj,jpts) , risf_par_tsc_b(jpi,jpj,jpts) , STAT=ialloc )
+      ierr = ierr + ialloc
+      !
+      ALLOCATE( risf_cav_tsc(jpi,jpj,jpts) , risf_cav_tsc_b(jpi,jpj,jpts) , STAT=ialloc )
+      ierr = ierr + ialloc
+      !
+      ALLOCATE( risfload(jpi,jpj) , STAT=ialloc )
+      ierr = ierr + ialloc
+      !
+      ALLOCATE( mskisf_cav(jpi,jpj) , STAT=ialloc )
       ierr = ierr + ialloc
       !
@@ -254,13 +258,13 @@
       !
       ! initalisation of fwf and tsc array to 0
-      risfload(:,:)       = 0.0_wp
-      fwfisf_oasis(:,:)   = 0.0_wp
-      fwfisf_par(:,:)     = 0.0_wp    ; fwfisf_par_b(:,:)     = 0.0_wp
-      fwfisf_cav(:,:)     = 0.0_wp    ; fwfisf_cav_b(:,:)     = 0.0_wp
-      risf_cav_tsc(:,:,:) = 0.0_wp    ; risf_cav_tsc_b(:,:,:) = 0.0_wp
-      risf_par_tsc(:,:,:) = 0.0_wp    ; risf_par_tsc_b(:,:,:) = 0.0_wp
-      !
-
+      risfload    (:,:)   = 0._wp
+      fwfisf_oasis(:,:)   = 0._wp
+      fwfisf_par  (:,:)   = 0._wp   ;   fwfisf_par_b  (:,:)   = 0._wp
+      fwfisf_cav  (:,:)   = 0._wp   ;   fwfisf_cav_b  (:,:)   = 0._wp
+      risf_cav_tsc(:,:,:) = 0._wp   ;   risf_cav_tsc_b(:,:,:) = 0._wp
+      risf_par_tsc(:,:,:) = 0._wp   ;   risf_par_tsc_b(:,:,:) = 0._wp
+      !
    END SUBROUTINE isf_alloc
-
+   
+   !!======================================================================
 END MODULE isf_oce
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/ISF/isfload.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/ISF/isfload.F90	(revision 14063)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/ISF/isfload.F90	(revision 14065)
@@ -2,5 +2,5 @@
    !!======================================================================
    !!                       ***  MODULE  isfload  ***
-   !! isfload module :  compute ice shelf load (needed for the hpg)
+   !! Ice Shelves :   compute ice shelf load (needed for the hpg)
    !!======================================================================
    !! History :  4.1  !  2019-09  (P. Mathiot) original code
@@ -8,5 +8,5 @@
 
    !!----------------------------------------------------------------------
-   !!   isfload      : compute ice shelf load
+   !!   isf_load      : compute ice shelf load
    !!----------------------------------------------------------------------
 
@@ -23,9 +23,14 @@
    PRIVATE
 
-   PUBLIC isf_load
+   PUBLIC   isf_load   ! called by isfstp.F90
+   !
    !! * Substitutions
 #  include "do_loop_substitute.h90"
 #  include "domzgr_substitute.h90"
-
+   !!----------------------------------------------------------------------
+   !! NEMO/OCE 4.0 , NEMO Consortium (2018)
+   !! $Id: sbcisf.F90 10536 2019-01-16 19:21:09Z mathiot $
+   !! Software governed by the CeCILL license (see ./LICENSE)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -37,8 +42,6 @@
       !!
       !!--------------------------------------------------------------------
-      !!-------------------------- OUT -------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(  out) :: pisfload
-      !!-------------------------- IN  -------------------------------------
-      INTEGER,                      INTENT(in)    :: Kmm           ! ocean time level index
+      INTEGER,                      INTENT(in   ) ::   Kmm        ! ocean time level index      
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(  out) ::   pisfload   ! ice shelf load
       !!----------------------------------------------------------------------
       !
@@ -46,5 +49,5 @@
       !               the smaller the residual flow is, the better it is.
       !
-      ! ice shelf cavity
+      ! type of ice shelf cavity
       SELECT CASE ( cn_isfload )
       CASE ( 'uniform' )
@@ -56,5 +59,6 @@
    END SUBROUTINE isf_load
 
-   SUBROUTINE isf_load_uniform( Kmm, pisfload )
+   
+   SUBROUTINE isf_load_uniform( Kmm, pload )
       !!--------------------------------------------------------------------
       !!                  ***  SUBROUTINE isf_load  ***
@@ -67,18 +71,13 @@
       !!
       !!--------------------------------------------------------------------
-      !!-------------------------- OUT -------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(  out) :: pisfload
-      !!-------------------------- IN  -------------------------------------
-      INTEGER,                      INTENT(in)    :: Kmm           ! ocean time level index
-      !!--------------------------------------------------------------------
+      INTEGER,                      INTENT(in   ) ::   Kmm     ! ocean time level index      
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(  out) ::   pload   ! ice shelf load
+      !
       INTEGER  :: ji, jj, jk
       INTEGER  :: ikt
-      REAL(wp)                          :: znad        ! 
       REAL(wp), DIMENSION(jpi,jpj)      :: zrhdtop_isf ! water density    displaced by the ice shelf (at the interface)
       REAL(wp), DIMENSION(jpi,jpj,jpts) :: zts_top     ! water properties displaced by the ice shelf   
       REAL(wp), DIMENSION(jpi,jpj,jpk)  :: zrhd        ! water density    displaced by the ice shelf
       !!----------------------------------------------------------------------
-      !
-      znad = 1._wp                     !- To use density and not density anomaly
       !
       !                                !- assume water displaced by the ice shelf is at T=rn_isfload_T and S=rn_isfload_S (rude)
@@ -87,4 +86,5 @@
       DO jk = 1, jpk                   !- compute density of the water displaced by the ice shelf 
          CALL eos( zts_top(:,:,:), gdept(:,:,jk,Kmm), zrhd(:,:,jk) )
+!!st ==>> CALL eos( zts_top(:,:,:), gdept_0(:,:,jk), zrhd(:,:,jk) )
       END DO
       !
@@ -93,23 +93,21 @@
       !
       !                                !- Surface value + ice shelf gradient
-      pisfload(:,:) = 0._wp                       ! compute pressure due to ice shelf load 
+      pload(:,:) = 0._wp                      ! compute pressure due to ice shelf load 
       DO_2D( 1, 1, 1, 1 )
          ikt = mikt(ji,jj)
          !
          IF ( ikt > 1 ) THEN
+            !                                 ! top layer of the ice shelf
+            pload(ji,jj) = pload(ji,jj)   &
+               &         + zrhd (ji,jj,1) * e3w(ji,jj,1,Kmm)
             !
-            ! top layer of the ice shelf
-            pisfload(ji,jj) = pisfload(ji,jj) + (znad + zrhd(ji,jj,1) )   &
-               &                                * e3w(ji,jj,1,Kmm)
-            !
-            ! core layers of the ice shelf
-            DO jk = 2, ikt-1
-               pisfload(ji,jj) = pisfload(ji,jj) + (2._wp * znad + zrhd(ji,jj,jk-1) + zrhd(ji,jj,jk))   &
-                  &                                * e3w(ji,jj,jk,Kmm)
+            DO jk = 2, ikt-1                  ! core layers of the ice shelf
+               pload(ji,jj) = pload(ji,jj) + (zrhd(ji,jj,jk-1) + zrhd(ji,jj,jk))   &
+                  &                        *   e3w(ji,jj,jk,Kmm)
             END DO
-            !
-            ! deepest part of the ice shelf (between deepest T point and ice/ocean interface
-            pisfload(ji,jj) = pisfload(ji,jj) + (2._wp * znad + zrhdtop_isf(ji,jj) + zrhd(ji,jj,ikt-1)) &
-               &                                              * ( risfdep(ji,jj) - gdept(ji,jj,ikt-1,Kmm) )
+            !                                 ! deepest part of the ice shelf (between deepest T point and ice/ocean interface
+            pload(ji,jj) = pload(ji,jj) + ( zrhdtop_isf(ji,jj) +  zrhd(ji,jj,ikt-1)     )   &
+               &                        * (     risfdep(ji,jj) - gdept(ji,jj,ikt-1,Kmm) )
+!!st ==>>     &                        * (     risfdep(ji,jj) - gdept_0(ji,jj,ikt-1) )
             !
          END IF
@@ -117,4 +115,5 @@
       !
    END SUBROUTINE isf_load_uniform
-
+   
+   !!======================================================================
 END MODULE isfload
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/ISF/isfstp.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/ISF/isfstp.F90	(revision 14063)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/ISF/isfstp.F90	(revision 14065)
@@ -2,5 +2,5 @@
    !!======================================================================
    !!                       ***  MODULE  isfstp  ***
-   !! Surface module :  compute iceshelf load, melt and heat flux
+   !! Ice Shelves :  compute iceshelf load, melt and heat flux
    !!======================================================================
    !! History :  3.2  !  2011-02  (C.Harris  ) Original code isf cav
@@ -42,8 +42,7 @@
    !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
-
 CONTAINS
  
-  SUBROUTINE isf_stp( kt, Kmm )
+   SUBROUTINE isf_stp( kt, Kmm )
       !!---------------------------------------------------------------------
       !!                  ***  ROUTINE isf_stp  ***
@@ -58,11 +57,12 @@
       !!              - compute fluxes
       !!              - write restart variables
-      !!
-      !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt   ! ocean time step
-      INTEGER, INTENT(in) ::   Kmm  ! ocean time level index
-      !!----------------------------------------------------------------------
-      INTEGER :: jk                               ! loop index
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: ze3t    ! e3t 
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt    ! ocean time step
+      INTEGER, INTENT(in) ::   Kmm   ! ocean time level index
+      !
+      INTEGER :: jk                              ! loop index
+#if defined key_qco
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: ze3t   ! 3D workspace
+#endif
       !!---------------------------------------------------------------------
       !
@@ -83,11 +83,15 @@
          ! 1.2: compute misfkb, rhisf_tbl, rfrac (deepest level, thickness, fraction of deepest cell affected by tbl)
          rhisf_tbl_cav(:,:) = rn_htbl * mskisf_cav(:,:)
+#if defined key_qco
          DO jk = 1, jpk
             ze3t(:,:,jk) = e3t(:,:,jk,Kmm)
          END DO 
-         CALL isf_tbl_lvl(ht(:,:), ze3t, misfkt_cav, misfkb_cav, rhisf_tbl_cav, rfrac_tbl_cav)
+         CALL isf_tbl_lvl( ht(:,:), ze3t, misfkt_cav, misfkb_cav, rhisf_tbl_cav, rfrac_tbl_cav )
+#else
+         CALL isf_tbl_lvl( ht(:,:),  e3t, misfkt_cav, misfkb_cav, rhisf_tbl_cav, rfrac_tbl_cav )
+#endif
          !
          ! 1.3: compute ice shelf melt
-         CALL isf_cav( kt, Kmm, risf_cav_tsc, fwfisf_cav)
+         CALL isf_cav( kt, Kmm, risf_cav_tsc, fwfisf_cav )
          !
       END IF
@@ -108,11 +112,15 @@
          ! by simplicity, we assume the top level where param applied do not change with time (done in init part)
          rhisf_tbl_par(:,:) = rhisf0_tbl_par(:,:)
+#if defined key_qco
          DO jk = 1, jpk
             ze3t(:,:,jk) = e3t(:,:,jk,Kmm)
          END DO
-         CALL isf_tbl_lvl(ht(:,:), ze3t, misfkt_par, misfkb_par, rhisf_tbl_par, rfrac_tbl_par)
+         CALL isf_tbl_lvl( ht(:,:), ze3t, misfkt_par, misfkb_par, rhisf_tbl_par, rfrac_tbl_par )
+#else
+         CALL isf_tbl_lvl( ht(:,:),  e3t, misfkt_par, misfkb_par, rhisf_tbl_par, rfrac_tbl_par )
+#endif
          !
          ! 2.3: compute ice shelf melt
-         CALL isf_par( kt, Kmm, risf_par_tsc, fwfisf_par)
+         CALL isf_par( kt, Kmm, risf_par_tsc, fwfisf_par )
          !
       END IF
@@ -128,5 +136,6 @@
    END SUBROUTINE isf_stp
 
-   SUBROUTINE isf_init(Kbb, Kmm, Kaa)
+   
+   SUBROUTINE isf_init( Kbb, Kmm, Kaa )
       !!---------------------------------------------------------------------
       !!                  ***  ROUTINE isfstp_init  ***
@@ -142,34 +151,25 @@
       !!              - call cav/param/isfcpl init routine
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) :: Kbb, Kmm, Kaa      ! ocean time level indices
+      INTEGER, INTENT(in) ::   Kbb, Kmm, Kaa   ! ocean time level indices
+      !!----------------------------------------------------------------------
       !
       ! constrain: l_isfoasis need to be known
       !
-      ! Read namelist
-      CALL isf_nam()
-      !
-      ! Allocate public array
-      CALL isf_alloc()
-      !
-      ! check option compatibility
-      CALL isf_ctl()
-      !
-      ! compute ice shelf load
-      IF ( ln_isfcav ) CALL isf_load( Kmm, risfload )
+      CALL isf_nam()                                              ! Read namelist
+      !
+      CALL isf_alloc()                                            ! Allocate public array
+      !
+      CALL isf_ctl()                                              ! check option compatibility
+      !
+      IF( ln_isfcav ) CALL isf_load( Kmm, risfload )              ! compute ice shelf load
       !
       ! terminate routine now if no ice shelf melt formulation specify
-      IF ( ln_isf ) THEN
-         !
-         !---------------------------------------------------------------------------------------------------------------------
-         ! initialisation melt in the cavity
-         IF ( ln_isfcav_mlt ) CALL isf_cav_init()
-         !
-         !---------------------------------------------------------------------------------------------------------------------
-         ! initialisation parametrised melt
-         IF ( ln_isfpar_mlt ) CALL isf_par_init()
-         !
-         !---------------------------------------------------------------------------------------------------------------------
-         ! initialisation ice sheet coupling
-         IF( ln_isfcpl ) CALL isfcpl_init(Kbb, Kmm, Kaa)
+      IF( ln_isf ) THEN
+         !
+         IF( ln_isfcav_mlt )   CALL isf_cav_init()                ! initialisation melt in the cavity
+         !
+         IF( ln_isfpar_mlt )   CALL isf_par_init()                ! initialisation parametrised melt
+         !
+         IF( ln_isfcpl     )   CALL isfcpl_init( Kbb, Kmm, Kaa )  ! initialisation ice sheet coupling
          !
       END IF
@@ -177,4 +177,5 @@
   END SUBROUTINE isf_init
 
+  
   SUBROUTINE isf_ctl()
       !!---------------------------------------------------------------------
@@ -283,5 +284,6 @@
       END IF
    END SUBROUTINE isf_ctl
-   !
+
+   
    SUBROUTINE isf_nam
       !!---------------------------------------------------------------------
